# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.DeidentifyErrorDetails do
  @moduledoc """
  Contains the status of the Deidentify operation.

  ## Attributes

  *   `failureResourceCount` (*type:* `String.t`, *default:* `nil`) - Number of resources that failed to process.
  *   `failureStoreCount` (*type:* `String.t`, *default:* `nil`) - Number of stores that failed to process.
  *   `successResourceCount` (*type:* `String.t`, *default:* `nil`) - Number of resources successfully processed.
  *   `successStoreCount` (*type:* `String.t`, *default:* `nil`) - Number of stores successfully processed.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :failureResourceCount => String.t(),
          :failureStoreCount => String.t(),
          :successResourceCount => String.t(),
          :successStoreCount => String.t()
        }

  field(:failureResourceCount)
  field(:failureStoreCount)
  field(:successResourceCount)
  field(:successStoreCount)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.DeidentifyErrorDetails do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.DeidentifyErrorDetails.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.DeidentifyErrorDetails do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
