# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.Finding do
  @moduledoc """


  ## Attributes

  *   `end` (*type:* `String.t`, *default:* `nil`) - Zero-based ending index of the found text, exclusively.
  *   `infoType` (*type:* `String.t`, *default:* `nil`) - The type of information stored in this text range. For example,
      HumanName, BirthDate, or Address.
  *   `quote` (*type:* `String.t`, *default:* `nil`) - The snippet of the sensitive text. This field is only populated during
      deidentification if `store_quote` is set to true in DeidentifyConfig.
  *   `start` (*type:* `String.t`, *default:* `nil`) - Zero-based starting index of the found text, inclusively.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :end => String.t(),
          :infoType => String.t(),
          :quote => String.t(),
          :start => String.t()
        }

  field(:end)
  field(:infoType)
  field(:quote)
  field(:start)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.Finding do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.Finding.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.Finding do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
