# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.ImageAnnotation do
  @moduledoc """
  Image annotation.

  ## Attributes

  *   `boundingPolys` (*type:* `list(GoogleApi.HealthCare.V1beta1.Model.BoundingPoly.t)`, *default:* `nil`) - The list of polygons outlining the sensitive regions in the image.
  *   `frameIndex` (*type:* `integer()`, *default:* `nil`) - 0-based index of the image frame. For example, an image frame in a DICOM
      instance.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :boundingPolys => list(GoogleApi.HealthCare.V1beta1.Model.BoundingPoly.t()),
          :frameIndex => integer()
        }

  field(:boundingPolys, as: GoogleApi.HealthCare.V1beta1.Model.BoundingPoly, type: :list)
  field(:frameIndex)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.ImageAnnotation do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.ImageAnnotation.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.ImageAnnotation do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
