# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.OperationMetadata do
  @moduledoc """
  OperationMetadata provides information about the operation execution.
  Returned in the long-running operation's metadata field.

  ## Attributes

  *   `apiMethodName` (*type:* `String.t`, *default:* `nil`) - The name of the API method that initiated the operation.
  *   `cancelRequested` (*type:* `boolean()`, *default:* `nil`) - Specifies if cancellation was requested for the operation.
  *   `counter` (*type:* `GoogleApi.HealthCare.V1beta1.Model.ProgressCounter.t`, *default:* `nil`) - 
  *   `createTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which the operation was created by the API.
  *   `endTime` (*type:* `DateTime.t`, *default:* `nil`) - The time at which execution was completed.
  *   `logsUrl` (*type:* `String.t`, *default:* `nil`) - A link to audit and error logs in the log viewer. Error logs are generated
      only by some operations, listed at
      [Viewing logs](/healthcare/docs/how-tos/logging).
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :apiMethodName => String.t(),
          :cancelRequested => boolean(),
          :counter => GoogleApi.HealthCare.V1beta1.Model.ProgressCounter.t(),
          :createTime => DateTime.t(),
          :endTime => DateTime.t(),
          :logsUrl => String.t()
        }

  field(:apiMethodName)
  field(:cancelRequested)
  field(:counter, as: GoogleApi.HealthCare.V1beta1.Model.ProgressCounter)
  field(:createTime, as: DateTime)
  field(:endTime, as: DateTime)
  field(:logsUrl)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.OperationMetadata do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.OperationMetadata.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.OperationMetadata do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
