# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.SearchResourcesRequest do
  @moduledoc """
  Request to search the resources in the specified FHIR store.

  ## Attributes

  *   `resourceType` (*type:* `String.t`, *default:* `nil`) - The FHIR resource type to search, such as Patient or Observation. For a
      complete list, see the FHIR Resource Index
      ([DSTU2](https://hl7.org/implement/standards/fhir/DSTU2/resourcelist.html),
      [STU3](https://hl7.org/implement/standards/fhir/STU3/resourcelist.html),
      [R4](https://hl7.org/implement/standards/fhir/R4/resourcelist.html)).
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :resourceType => String.t()
        }

  field(:resourceType)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.SearchResourcesRequest do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.SearchResourcesRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.SearchResourcesRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
