# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.HealthCare.V1beta1.Model.SensitiveTextAnnotation do
  @moduledoc """
  A TextAnnotation specifies a text range that includes sensitive information.

  ## Attributes

  *   `details` (*type:* `%{optional(String.t) => GoogleApi.HealthCare.V1beta1.Model.Detail.t}`, *default:* `nil`) - Maps from a resource slice. For example, FHIR resource field path to a set
      of sensitive text findings. For example,
      Appointment.Narrative text1 --> {findings_1, findings_2, findings_3}
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :details => %{optional(String.t()) => GoogleApi.HealthCare.V1beta1.Model.Detail.t()}
        }

  field(:details, as: GoogleApi.HealthCare.V1beta1.Model.Detail, type: :map)
end

defimpl Poison.Decoder, for: GoogleApi.HealthCare.V1beta1.Model.SensitiveTextAnnotation do
  def decode(value, options) do
    GoogleApi.HealthCare.V1beta1.Model.SensitiveTextAnnotation.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.HealthCare.V1beta1.Model.SensitiveTextAnnotation do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
